#include "memoire.h"

/*
 * Lit un bloc de TAILLE_BLOC octets de la mémoire vive
 * et retourne le nombre de bits à '1'
 */
int lire_memoire(int baseaddr) {
	unsigned int nb_bits_a_1 = 0;
	unsigned char val;
	/* Définition d'un pointeur vers l'adresse mémoire souhaité */
	unsigned char *c = baseaddr;
	int i;
	for(i = 0; i < TAILLE_BLOC; i++) {
		/* Lecture de la valeur pointée et incrémentation du pointeur */
		val = *c++;
		nb_bits_a_1 += compteur_de_1((int)val);
	}
	return nb_bits_a_1;
}

/*
 * Ecrit un motif dans un bloc de TAILLE_BLOC octets de la mémoire vive
 */
void ecrire_memoire(int baseaddr, unsigned char motif) {
	int i;
	/* Ne pas écrire sur la mémoire vidéo, le bios, etc. */
	if(baseaddr < 2200000)
		return;

	/* Définition d'un pointeur vers l'adresse mémoire souhaité */
	unsigned char *c = baseaddr;
	for(i = 0; i < TAILLE_BLOC; i++) {
		/* Ecriture de la valeur dans la case mémoire pointée par le
		 * pointeur et incrémenté ce dernier 
		 */
		*c++ = motif;
	}
	return;
}

/* 
 * Permet de compter le nombre de bit à '1' dans un entier
 */
unsigned char compteur_de_1(unsigned int val) {
	unsigned char nb_bits_a_1 = 0;
	int i;
	int b;
	if(val < 256)
		b = 8;
	else if(val < 65536)
		b = 16;
	else
		b = 32;

	for(i = 0; i < b; i++) {
		nb_bits_a_1 += (val >> i) & 1;
	}
	return nb_bits_a_1;
}


unsigned char get_motif(int x, int y) {
	unsigned char motif = (x*y+42)%256;
	return motif;
}
